#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

&start;



sub start
{

#print "Content-type: text/html\n\n";

$fct = $q->param('fct');
$C0 = $q->param('C0');
$cid = $q->param('cid');
$ct = $q->param('ct');
@cts = split (/-/, $ct);
$cntrs = 0;

### GET PARAMETRES TO EDIT/MOVE/DELETE/COPY LINK

foreach $item (@cts)
	{
	$ctsarray[$cntrs] = acs::decode_dir($item);
	$ctsarray[$cntrs] =~ s/'/\\'/g;
	$cntrs++;
	}
	$arrcnt = @ctsarray;


$sql = "SELECT cid, level FROM dirs WHERE ";
$sqlcnt = 1;
	
	for ($ms = 0; $ms < $arrcnt; $ms++)
		{
			$sqcntr = 1;
			foreach $item (@ctsarray)
				{
				if ($item ne "")
					{
					if ($sqcntr == 1) { $sql_crit = $sql_crit . "("; }
					$sql_crit = $sql_crit . "(l$sqcntr = '$item') and ";
					$sqcntr++;
					}
				}
			$sql_crit = $sql_crit . "(l$sqcntr = '')) or ";
			
		 $ctsarray[$sqcntr - 2] = "";
		}

$sql_crit = substr($sql_crit, 0, length($sql_crit) - 3);
$sql_crit = "SELECT cid, level FROM dirs WHERE $sql_crit ORDER BY level ASC";


### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

#print "==> $sql_crit <BR>";

$sth = $dbh->prepare($sql_crit);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}

while ( @row = $sth->fetchrow() )
	{
	$rid_crit = $rid_crit . "$row[0]" . "-";
	}


if ($q->param('fct') ne "gotocat")
	{
	#print "Content-type: text/html\n\n";
	
	if ($q->param('del_only_one') eq "true")
		{
		#print "Content-type: text/html\n\n";
		$location = "$admin_url/admin5.cgi?fct=delete_operation&rid=$rid_crit&lnks=$C0&cid=$cid";
		print "Location: $location\n\n";
		}
		else
		{
		$location = "$admin_url/admin5.cgi?opaction=$fct&fct=link_functions&cid=$cid&nr_links=1&C0=$C0&ct=$ct&rid=$rid_crit";
		print "Location: $location\n\n";
		}
	
	}
	else
	{
	#print "Content-type: text/html\n\n";
	chop($rid_crit);
	$location = "$admin_url/admin2.cgi?lv=$arrcnt&ct=$ct&cid=$cid&rid=$rid_crit";
	print "Location: $location\n\n";
	}

$sth->finish;
$dbh->disconnect; 

}




sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}






sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

